VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EnumIDList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "ID Enumerator"
'*********************************************************************************************
'
' Shell Namespace sample
'
' EnumIDList class
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB, mdlIDLIST.bas
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

' Implement the IEnumIDList interface
Implements olelib.IEnumIDList

Private m_lFlags As olelib.SHCONTF
Private m_lFileCount As Long
Private m_lCurrentPos As Long
Private m_asPIDLs() As Long
Private m_sGroup As String
Private Sub pvReadGroupFile()
Dim lFF As Long
Dim sLine As String
Dim sPath As String
Dim sFull As String

   m_lCurrentPos = 0
   m_lFileCount = 0
   Erase m_asPIDLs
   
   lFF = FreeFile
   
   sPath = GetFolder(m_sGroup)
   
   Open m_sGroup For Input As lFF
   
   Line Input #lFF, sLine
   
   Do While Not EOF(lFF)
      
      Line Input #lFF, sLine
      
      sLine = Mid$(sLine, InStr(sLine, "=") + 1)
      sFull = Space$(260)
      PathCombine sFull, sPath, sLine
      sFull = RTrimNull(sFull)
      
      ReDim Preserve m_asPIDLs(0 To m_lFileCount)
      m_asPIDLs(m_lFileCount) = CreateSimplePIDL(sFull, SFGAO_CANLINK Or SFGAO_READONLY)
      
      m_lFileCount = m_lFileCount + 1
      
   Loop
   
   Close lFF
   
End Sub

'
' pvReadRegistry
'
' Reads the recent projects from the registry
'
Private Sub pvReadRegistry()
Dim hKey As Long
Dim lIdx As Long
Dim lCount As Long
Dim lRes As Long
Dim sValue As String, sName As String
Dim lValueLen As Long, lNameLen As Long, lType As Long
Dim sRegKey As String, lFlags As SFGAO_Flags
Dim bProject As Boolean
Dim bEnumFolders As Boolean
Dim bEnumFiles As Boolean

   bEnumFolders = (m_lFlags And SHCONTF_FOLDERS) = SHCONTF_FOLDERS
   bEnumFiles = (m_lFlags And SHCONTF_NONFOLDERS) = SHCONTF_NONFOLDERS
   
   If GetVBVersion() = 5 Then
      sRegKey = REG_KEYVB5
   Else
      sRegKey = REG_KEYVB6
   End If
   
   ' Open the registry key
   If RegOpenKeyEx(HKEY_CURRENT_USER, sRegKey, 0, KEY_READ, hKey) = 0 Then

      ' Get the values count
      RegQueryInfoKey hKey, ByVal 0&, ByVal 0&, 0, _
                     ByVal 0&, ByVal 0&, ByVal 0&, lCount, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&
      
      ReDim m_asPIDLs(0 To lCount - 1)
     
      For lIdx = 0 To lCount - 1
      
         sValue = String$(260, 0)
         lValueLen = 260
         sName = String$(260, 0)
         lNameLen = 260
         
         ' Get the value name
         lRes = RegEnumValueStr(hKey, lIdx, sName, lNameLen, 0, lType, sValue, lValueLen)
         sValue = GetLongPath(sValue)
         
         bProject = IsProject(sValue)
      
         If (bEnumFiles And bProject) Or _
            (bEnumFolders And Not bProject) Then
         
            ' Check if the file exists
            If FileExist(sValue) Then
               
               lFlags = SFGAO_CANLINK Or SFGAO_READONLY
               If Not bProject Then lFlags = lFlags Or SFGAO_BROWSABLE Or SFGAO_FOLDER Or SFGAO_FILESYSANCESTOR
               
               m_asPIDLs(m_lFileCount) = CreateSimplePIDL(sValue, lFlags)
               
               ' Increment the file count
               m_lFileCount = m_lFileCount + 1
               
            End If
            
         End If
         
      Next

      ReDim Preserve m_asPIDLs(0 To m_lFileCount - 1)
      
      ' Close the key
      RegCloseKey hKey

   End If

End Sub
Friend Sub Initialize(ByVal Group As String, ByVal Flags As Long)

   m_lFlags = Flags
   m_sGroup = Group
      
   If LenB(Group) = 0 Then
      pvReadRegistry
   Else
      pvReadGroupFile
   End If
   
End Sub

Private Function IEnumIDList_Clone() As olelib.IEnumIDList
Dim oEnumIDL As EnumIDList

   ' Create a new EnumIDList object
   Set oEnumIDL = New EnumIDList
   
   ' Initialize the new object
   oEnumIDL.Initialize m_sGroup, m_lFlags
   
   ' Return the new object
   Set IEnumIDList_Clone = oEnumIDL
   
End Function

Private Function IEnumIDList_Next(ByVal celt As Long, rgelt As Long) As Long
Dim lFlags As Long

   If m_lCurrentPos < m_lFileCount Then
   
      ' Return the next PIDL
      rgelt = m_asPIDLs(m_lCurrentPos)
      
      ' Increment the current position
      m_lCurrentPos = m_lCurrentPos + 1
      
      ' The function returns 1 PIDL
      IEnumIDList_Next = 1
   
   Else
      
      ' Raise an error
      Err.Raise E_FAIL
      
   End If
   
End Function
'
' Resets the enumeration
'
Private Sub IEnumIDList_Reset()
   
   ' Reset current position
   m_lCurrentPos = 0
   
End Sub


Private Sub IEnumIDList_Skip(ByVal celt As Long)

   m_lCurrentPos = m_lCurrentPos + celt
   
End Sub


