VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ExtractIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Item Icon handler"
'*********************************************************************************************
'
' Shell Namespace sample
'
' Icon handler
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: olelib.TLB
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

' Implement then IExtractIcon interface
Implements IExtractIconA ' For Win95/98/Me
Implements IExtractIconW ' For NT/2K/XP

' Full path of the file which icon will
' be extracted
Private m_sFile As String

Friend Property Let File(ByVal NewFile As String)
   m_sFile = NewFile
End Property

Private Sub IExtractIconA_Extract(ByVal pszFile As Long, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIconSize As Long)
Dim sFile As String

   ' Get the filename from the pointer
   sFile = StrFromPtr(pszFile)
   
   ' Extract the icon from the file
   ExtractIconEx sFile, nIconIndex, phiconLarge, phiconSmall, 1
   
End Sub

Private Function IExtractIconA_GetIconLocation(ByVal uFlags As olelib.GILFlags, ByVal szIconFile As Long, ByVal cchMax As Long, piIndex As Long) As olelib.GILRes
Dim sDllFile As String

   sDllFile = App.Path & "\" & App.EXEName & ".dll"
   
   ' Copy the filename to the buffer
   lstrcpynA ByVal szIconFile, ByVal sDllFile, cchMax
   
   ' Set the icon index
   If IsProject(m_sFile) Then
      piIndex = 1 ' Return the project icon
   Else
      piIndex = 2 ' Return project group icon
   End If
   
   ' Return flags
   IExtractIconA_GetIconLocation = GIL_PERINSTANCE
   
End Function


Private Sub IExtractIconW_Extract(ByVal pwszFile As Long, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIconSize As Long)
Dim sFile As String

   ' Get the filename from the pointer
   sFile = SysAllocString(pwszFile)
      
   ' Extract the icon from the file
   ExtractIconEx sFile, nIconIndex, phiconLarge, phiconSmall, 1

End Sub

Private Function IExtractIconW_GetIconLocation(ByVal uFlags As olelib.GILFlags, ByVal pwszIconFile As Long, ByVal cchMax As Long, piIndex As Long) As olelib.GILRes
Dim sDllFile As String

   sDllFile = App.Path & "\" & App.EXEName & ".dll"
      
   ' Copy the filename to the buffer
   MoveMemory ByVal pwszIconFile, ByVal StrPtr(sDllFile), cchMax
   
   ' Set the icon index
   If IsProject(m_sFile) Then
      piIndex = 1 ' Return the project icon
   Else
      piIndex = 2 ' Return project group icon
   End If
   
   ' Return flags
   IExtractIconW_GetIconLocation = GIL_PERINSTANCE Or GIL_DONTCACHE

End Function
