VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ShellFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "VB Recent Projects"
'*********************************************************************************************
'
' Shell Namespace sample
'
' ShellFolder class
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

Implements olelib.IPersist
Implements olelib.IPersistFolder
Implements olelib.IShellFolder

Private m_lThis As Long
Private m_sGroup As String

Friend Property Get PIDL() As Long
   PIDL = m_lThis
End Property

Friend Property Let Group(ByVal NewGroup As String)
   m_sGroup = NewGroup
End Property



Private Sub Class_Terminate()

   ' Release the PIDL
   g_oMalloc.Free m_lThis
   
End Sub

'*********************************************************************************************
' Returns the CLSID of this object
'*********************************************************************************************
Private Sub IPersist_GetClassID(pClassID As olelib.UUID)

    CLSIDFromProgID "prjNameSpace.ShellFolder", pClassID

End Sub

Private Sub IPersistFolder_GetClassID(lpClassID As olelib.UUID)

    IPersist_GetClassID lpClassID
    
End Sub

'*********************************************************************************************
' Initializes the namespace
'
' Parameters:
'
' lPIDL:     Pointer to an ITEMIDLIST that represents this folder
'*********************************************************************************************
Private Sub IPersistFolder_Initialize(ByVal lPIDL As Long)

   ' Copy the PIDL
   m_lThis = CopyPIDL(lPIDL)
      
End Sub


'*********************************************************************************************
' BindToObject - Retrieves an IShellFolder object for a subfolder.
'*********************************************************************************************
Private Sub IShellFolder_BindToObject(ByVal PIDL As Long, ByVal pbcReserved As Long, riid As olelib.UUID, ppvOut As Long)
Dim oUnk As olelib.IUnknown
Dim oISF As IPersistFolder

   If GetPIDLAttributes(PIDL) And SFGAO_FOLDER Then
      
      Dim oSF As ShellFolder, lPIDL As Long
      
      Set oSF = New ShellFolder
      
      ' Query the interface
      Set oUnk = oSF
      If oUnk.QueryInterface(riid, ppvOut) <> S_OK Then Err.Raise E_NOINTERFACE
         
      ' Create the absolute PIDL for
      ' the new folder
      lPIDL = AddPIDLs(m_lThis, PIDL)
        
      ' Initialize the new ShellFolder
      oSF.Group = GetPIDLName(PIDL)
      Set oISF = oSF
      oISF.Initialize lPIDL
      
      ' Release the absolute PIDL
      g_oMalloc.Free lPIDL
      
   Else
      Err.Raise E_INVALIDARG
   End If

End Sub

'*********************************************************************************************
' Not used. Must return E_NOTIMPL
'*********************************************************************************************
Private Function IShellFolder_BindToStorage(ByVal lPIDL As Long, ByVal pbcReserved As Long, riid As olelib.UUID) As olelib.IStorage

   ' NOT IMPLEMENTED
   Err.Raise E_NOTIMPL
    
End Function

'*********************************************************************************************
' Determines the relative order of two file objects or folders, given their tItem identifier lists.
'*********************************************************************************************
Private Sub IShellFolder_CompareIDs(ByVal lParam As Long, ByVal pidl1 As Long, ByVal pidl2 As Long)
    
    ' This sub is replaced in the vtable
    ' with the one in the .bas module.
  
End Sub

'*********************************************************************************************
' Creates a view object of a folder.
'*********************************************************************************************
Private Function IShellFolder_CreateViewObject(ByVal hwndOwner As Long, riid As olelib.UUID) As Long
Dim oUnk As olelib.IUnknown
Dim oShellView As frmShellView
      
   ' Compare the interface ID
   ' with the IShellView ID
   If IsEqualGUID(riid, IID_IShellView2) Or _
      IsEqualGUID(riid, IID_IShellView) Then
            
      ' Create the IShellView object
      Set oShellView = New frmShellView
      
      ' Pass this folder to the
      ' IShellView object
      Set oShellView.ShellFolder = Me
      
      ' Query for the requested interface
      Set oUnk = oShellView
      oUnk.QueryInterface riid, IShellFolder_CreateViewObject
   
   Else
      
      ' Return NO SUCH INTERFACE SUPPORTED
      Err.Raise E_NOINTERFACE
      
   End If
    
End Function

'*********************************************************************************************
' Allows a client to determine the contents of a folder by creating an
' tItem identifier enumeration object and returning its IEnumIDList interface.
'*********************************************************************************************
Private Function IShellFolder_EnumObjects(ByVal hwndOwner As Long, ByVal grfFlags As olelib.SHCONTF) As olelib.IEnumIDList
Dim oEnum As EnumIDList

   ' Create a new IEnumIDList
   ' object
   Set oEnum = New EnumIDList
   oEnum.Initialize m_sGroup, grfFlags
    
   ' Return the enum object
   Set IShellFolder_EnumObjects = oEnum
   
End Function

'*********************************************************************************************
' Retrieves the attributes of one or more file objects or subfolders.
'*********************************************************************************************
Private Sub IShellFolder_GetAttributesOf(ByVal cidl As Long, apidl As Long, rgfInOut As Long)

   ' All items on this namespace
   ' have the same attributes
   rgfInOut = rgfInOut And (GetPIDLAttributes(apidl))
   
End Sub
'*********************************************************************************************
' Retrieves the display name for the specified file object or subfolder.
'*********************************************************************************************
Private Sub IShellFolder_GetDisplayNameOf(ByVal lPIDL As Long, ByVal uFlags As olelib.SHGNO_Flags, lpName As olelib.STRRET)
Dim sDisplayName As String, lReturnPtr As Long
      
   If lPIDL Then
   
      On Error Resume Next
      
      ' Get the filename from the lPIDL
      sDisplayName = GetPIDLName(lPIDL)
            
      If (uFlags And SHGDN_FORADDRESSBAR) Or _
         (uFlags And SHGDN_FORPARSING) Then
         
         ' Return only the filename
         sDisplayName = GetFilename(sDisplayName)
         
      ElseIf (uFlags And SHGDN_INFOLDER) Then
               
         ' Return project title
         sDisplayName = GetProjectTitle(sDisplayName)
   
      End If
       
      ' Return the a pointer to a Unicode string
      lpName.uType = STRRET_WSTR
      
      ' Alloc memory for the string
      lReturnPtr = g_oMalloc.Alloc(LenB(sDisplayName) + 2)
      
      ' Copy sDisplayName to the buffer
      MoveMemory ByVal lReturnPtr, ByVal StrPtr(sDisplayName), LenB(sDisplayName) + 2
      
      ' Set the pointer in plName
      MoveMemory lpName.CStr(0), lReturnPtr, 4
      
   Else
   
      ' Invalid pointer
      Err.Raise E_POINTER
      
   End If
   
End Sub


'*********************************************************************************************
' Retrieves an OLE interface that can be used to carry out actions on the
' specified file objects or folders.
'*********************************************************************************************
Private Function IShellFolder_GetUIObjectOf(ByVal hwndOwner As Long, ByVal cidl As Long, apidl As Long, riid As olelib.UUID, prgfInOut As Long) As Long
Dim oUnk As olelib.IUnknown, sFile As String
Dim oExtractIcon As ExtractIcon
   
   If (IsEqualGUID(riid, IID_IExtractIconA) Or _
       IsEqualGUID(riid, IID_IExtractIconW)) And cidl = 1 Then
   
      Set oExtractIcon = New ExtractIcon
      
      ' Pass the filename to the ExtractIcon
      oExtractIcon.File = GetPIDLName(apidl)
      
      Set oUnk = oExtractIcon
   
   ElseIf IsEqualGUID(riid, IID_IContextMenu) Then
      
      Dim oCtxMenu As ContextMenu
      Dim lIdx As Long, lPIDL As Long
      
      ' Create the ContextMenu object
      Set oCtxMenu = New ContextMenu
      
      ' Fill the filenames array
      For lIdx = 0 To cidl - 1
      
         ' Get the next lPIDL in the array
         MoveMemory lPIDL, ByVal VarPtr(apidl) + (4 * lIdx), 4
              
         ' Get the filename from the lPIDL
         ' and add it to the files array
         oCtxMenu.AddFile GetPIDLName(lPIDL)
      
      Next

      Set oUnk = oCtxMenu
      
   Else
   
      Err.Raise E_NOINTERFACE
      
   End If
      
   ' Query for the requested interface
   oUnk.QueryInterface riid, IShellFolder_GetUIObjectOf

End Function


'*********************************************************************************************
' Translates a file object's or folder's display name into an tItem identifier list.
'*********************************************************************************************
Private Sub IShellFolder_ParseDisplayName(ByVal hwndOwner As Long, ByVal pbcReserved As Long, ByVal lpszDisplayName As Long, pchEaten As Long, ppidl As Long, pdwAttributes As Long)

   Err.Raise E_NOTIMPL
    
End Sub

'*********************************************************************************************
' Sets the display name of a file object or subfolder, changing the tItem
' identifier in the process.
'*********************************************************************************************
Private Function IShellFolder_SetNameOf(ByVal hwndOwner As Long, ByVal lPIDL As Long, ByVal lpszName As Long, ByVal uFlags As olelib.SHGNO_Flags) As Long

   Err.Raise E_NOTIMPL
    
End Function


Private Sub Class_Initialize()
Dim ShlFldr As IShellFolder

   On Error Resume Next
   
   ' Get the IShellFolder
   ' interface
   Set ShlFldr = Me
   
   ' Replace the CompareIDs
   ' member. CompareIDs is the 5th
   ' entry in the IShellFolder
   ' interface, but there're 3
   ' entries for IUnknown
   ReplaceVTableEntry ObjPtr(ShlFldr), 8, AddressOf mdlReplacedEntries.IShellFolder_CompareIDs
       
End Sub
