VERSION 5.00
Begin VB.Form frmShellView 
   BackColor       =   &H000000FF&
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   3315
   ClientLeft      =   3990
   ClientTop       =   4020
   ClientWidth     =   5625
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   Moveable        =   0   'False
   ScaleHeight     =   221
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   375
   ShowInTaskbar   =   0   'False
   Begin VBRecent.WebView WebView 
      Height          =   1335
      Left            =   2130
      TabIndex        =   1
      Top             =   1755
      Width           =   1710
      _ExtentX        =   3016
      _ExtentY        =   2355
   End
   Begin VBRecent.ClassicView ClassicView 
      Height          =   1125
      Left            =   135
      TabIndex        =   0
      Top             =   195
      Width           =   1485
      _ExtentX        =   2619
      _ExtentY        =   1984
   End
End
Attribute VB_Name = "frmShellView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Attribute VB_Description = "ShellView object"
'*********************************************************************************************
'
' Shell Namespace sample
'
' ShellView class
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB, ClassicView.ctl, WebView.ctl
'
' History:
'          03/29/2002 - Fixed a bug that made the form
'                       crash in NT.
'          12/29/2000 - The shellview now implements IShellView2 to
'                       allow the Web View.
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

' Implement IShellView
Implements IShellView
Implements IShellView2

' Browser window
Dim m_oBrowser As IShellBrowser
Dim m_lSettingsFlags As Long

' Parent folder
Private m_oIShellFolder As IShellFolder

' Current view
Dim m_lCurrentView As Long
Dim m_oCurrentView As IView

' Main menu handle
Dim m_hMenu As Long

' Handle to File and Help submenues
Dim m_hMenuFile As Long
Dim m_hMenuView As Long
Dim m_hMenuTools As Long
Dim m_hMenuHelp As Long

'*********************************************************************************************
'
' DeleteMenus
'
' Detaches the menu and destroys its handle.
'
'*********************************************************************************************
Private Sub DeleteMenus()

   ' Reset the menu bar
   m_oBrowser.SetMenuSB 0, 0, 0
   
   ' Let Explorer remove its menus
   ' from the menu
   m_oBrowser.RemoveMenusSB m_hMenu
   
   ' Delete the menu
   DestroyMenu m_hMenu
   
   m_hMenu = 0
   
End Sub

'*********************************************************************************************
'
' InitializeMenus
'
' Creates the menu and attaches it to the
' browser window.
'
'*********************************************************************************************
Private Sub InitializeMenus(ByVal ForFolder As Boolean)
Dim MII As MENUITEMINFO
Dim MW As OLEMENUGROUPWIDTHS
   
   ' Create a menu
   m_hMenu = CreateMenu()
   
   ' Call InsertMenusSB to let the
   ' explorer add its menus
   m_oBrowser.InsertMenusSB m_hMenu, MW
   
   ' Delete the Edit menu
   DeleteMenu m_hMenu, FCIDM_MENU_EDIT, MF_BYCOMMAND
   
   ' Get the File menu
   MII.cbSize = Len(MII)
   MII.fMask = MIIM_SUBMENU
   GetMenuItemInfo m_hMenu, FCIDM_MENU_FILE, False, MII
   m_hMenuFile = MII.hSubMenu
   
   ' Get the View menu
   MII.cbSize = Len(MII)
   MII.fMask = MIIM_SUBMENU
   GetMenuItemInfo m_hMenu, FCIDM_MENU_VIEW, False, MII
   m_hMenuView = MII.hSubMenu
   
   ' Get the Tools menu
   MII.cbSize = Len(MII)
   MII.fMask = MIIM_SUBMENU
   GetMenuItemInfo m_hMenu, FCIDM_MENU_TOOLS, False, MII
   m_hMenuTools = MII.hSubMenu
   
   ' Get the Help menu
   MII.cbSize = Len(MII)
   MII.fMask = MIIM_SUBMENU
   GetMenuItemInfo m_hMenu, FCIDM_MENU_HELP, False, MII
   m_hMenuHelp = MII.hSubMenu
         
   ' Add items to File menu
   InsertMenu m_hMenuFile, 0, MF_BYPOSITION Or MF_SEPARATOR, 0, vbNullString
   InsertMenu m_hMenuFile, 0, MF_BYPOSITION Or MF_DISABLED Or MF_GRAYED, CMDID_FILE_OPEN, "&Open project"

   ' Add items to View menu
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND Or MF_SEPARATOR, 0, vbNullString
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND, CMDID_VIEW_WEB, "as &Web Page"
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND Or MF_SEPARATOR, 0, vbNullString
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND, CMDID_VIEW_LARGEICONS, "Lar&ge Icons"
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND, CMDID_VIEW_SMALLICONS, "S&mall Icons"
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND, CMDID_VIEW_LIST, "&List"
   InsertMenu m_hMenuView, FCIDM_MENU_VIEW_SEP_OPTIONS, MF_BYCOMMAND, CMDID_VIEW_DETAILS, "&Details"
   
   ' Check the current view tItem
   CheckMenuRadioItem m_hMenuView, CMDID_VIEW_LARGEICONS, CMDID_VIEW_DETAILS, CMDID_VIEW_LARGEICONS + m_oCurrentView.View, MF_BYCOMMAND
   
   ' Check the WebView item
   If m_lCurrentView = 1 Then CheckMenuItem m_hMenuView, CMDID_VIEW_WEB, MF_CHECKED
   
   ' Add tItem to the Tools menu
   InsertMenu m_hMenuTools, 0, MF_BYPOSITION Or MF_SEPARATOR, 0, vbNullString
   InsertMenu m_hMenuTools, 0, MF_BYPOSITION, CMDID_TOOLS_VB, "&Visual Basic"

   ' Add tItem to the Help menu
   AppendMenu m_hMenuHelp, MF_BYCOMMAND, CMDID_HELP_ABOUT, "About &Recent VB Projects"

   ' Set the explorer menu bar
   m_oBrowser.SetMenuSB m_hMenu, 0, Me.hWnd

End Sub

'*********************************************************************************************
'
' InitializeToolbar
'
' Sets the toolbar buttons.
'
'*********************************************************************************************
Private Sub InitializeToolbar()
Dim TB() As TBBUTTON, TBAB As TBADDBITMAP
Dim lOffsetStd As Long
Dim lOffsetView As Long
Dim lWebViewIdx As Long
Dim lAboutIdx As Long

   ' Reset the toolbar
   m_oBrowser.SetToolbarItems ByVal 0&, 0, FCT_MERGE
   
   ' Add std images
   TBAB.hInst = HINST_COMMCTRL
   TBAB.nID = IDB_STD_SMALL_COLOR
   lOffsetStd = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDBITMAP, 0, TBAB)
   
   ' Add view images
   TBAB.hInst = HINST_COMMCTRL
   TBAB.nID = IDB_VIEW_SMALL_COLOR
   lOffsetView = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDBITMAP, 0, TBAB)
   
   ' Add the WebView image
   TBAB.hInst = App.hInstance
   TBAB.nID = 2
   lWebViewIdx = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDBITMAP, 1, TBAB)
   
   ' Add the About image
   TBAB.hInst = App.hInstance
   TBAB.nID = 1
   lAboutIdx = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDBITMAP, 1, TBAB)
   
   ' Redim the button array
   ReDim TB(0 To 7)
   
   ' Set the buttons
   With TB(0)
      .iBitmap = VIEW_LARGEICONS + lOffsetView
      .idCommand = CMDID_VIEW_LARGEICONS
      .fsStyle = BTNS_CHECKGROUP
      .fsState = TBSTATE_ENABLED
      .iString = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDSTRINGW, 0, ByVal "Large icons")
   End With
   
   With TB(1)
      .iBitmap = VIEW_SMALLICONS + lOffsetView
      .idCommand = CMDID_VIEW_SMALLICONS
      .fsStyle = BTNS_CHECKGROUP
      .fsState = TBSTATE_ENABLED
      .iString = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDSTRINGW, 0, ByVal "Small icons")
   End With
   
   With TB(2)
      .iBitmap = VIEW_LIST + lOffsetView
      .idCommand = CMDID_VIEW_LIST
      .fsStyle = BTNS_CHECKGROUP
      .fsState = TBSTATE_ENABLED
      .iString = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDSTRINGW, 0, ByVal "List")
   End With
   
   With TB(3)
      .iBitmap = VIEW_DETAILS + lOffsetView
      .idCommand = CMDID_VIEW_DETAILS
      .fsStyle = BTNS_CHECKGROUP
      .fsState = TBSTATE_ENABLED
      .iString = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDSTRINGW, 0, ByVal "Details")
   End With
   
   With TB(4)
      .fsStyle = BTNS_SEP
   End With
   
   With TB(5)
      .iBitmap = lWebViewIdx
      .idCommand = CMDID_VIEW_WEB
      .fsStyle = BTNS_CHECK
      If m_lCurrentView = 1 Then
         .fsState = TBSTATE_ENABLED Or TBSTATE_CHECKED
      Else
         .fsState = TBSTATE_ENABLED
      End If
      .iString = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDSTRINGW, 0, ByVal "Web View")
   End With
   
   With TB(6)
      .fsStyle = BTNS_SEP
   End With
   
   With TB(7)
      .iBitmap = lAboutIdx
      .idCommand = CMDID_HELP_ABOUT
      .fsStyle = BTNS_BUTTON
      .fsState = TBSTATE_ENABLED
      .iString = m_oBrowser.SendControlMsg(FCW_TOOLBAR, TB_ADDSTRINGW, 0, ByVal "About...")
   End With
   
   ' Check the current view mode
   TB(m_oCurrentView.View).fsState = TB(m_oCurrentView.View).fsState Or TBSTATE_CHECKED
   
   ' Add buttons to the browser toolbar
   m_oBrowser.SetToolbarItems TB(0), UBound(TB) + 1, FCT_MERGE
   
End Sub

'*********************************************************************************************
'
' OnActivate
'
' Called whenever the view gets focused.
'
'*********************************************************************************************
Friend Sub OnActivate()
   
   ' Notify the browser that
   ' this window got focus
   m_oBrowser.OnViewWindowActive Me
      
   ' Update UI
   IShellView_UIActivate SVUIA_ACTIVATE_FOCUS

End Sub

'*********************************************************************************************
'
' OnCommand
'
' Called from the window procedure
' when a menu tItem is selected.
'
' Parameters:
'
' Cmd: CommandID of the selected menu tItem
'
'*********************************************************************************************
Public Sub OnCommand(ByVal wParam As Long)

   Select Case LOWORD(wParam)
   
      Case CMDID_HELP_ABOUT
         
         ' Show the about dialog
         MsgBox "This namespace was created by Eduardo A. Morcillo using Visual Basic." & vbCrLf & "Get the source code from http://www.domaindlx.com/e_morcillo.", vbInformation, "About Recent VB Projects"
      
      Case CMDID_FILE_OPEN
      
         ' Launch the project
         ShellExecute Me.hWnd, "open", m_oCurrentView.SelectedFile, vbNullString, vbNullString, SW_SHOW
      
      Case CMDID_VIEW_WEB
      
         Dim lView As Long
         
         If m_lCurrentView = 0 Then
            
            ' Check the menu item and toolbar button
            CheckMenuItem m_hMenuView, CMDID_VIEW_WEB, MF_CHECKED
            m_oBrowser.SendControlMsg FCW_TOOLBAR, TB_CHECKBUTTON, CMDID_VIEW_WEB, ByVal 1
            
            ' Set the current view
            m_lCurrentView = 1
            lView = m_oCurrentView.View
            Set m_oCurrentView = WebView.object
            m_oCurrentView.View = lView
                        
            WebView.Visible = True
            ClassicView.Visible = False
            
         Else
         
            ' Uncheck the menu item
            CheckMenuItem m_hMenuView, CMDID_VIEW_WEB, MF_UNCHECKED
            m_oBrowser.SendControlMsg FCW_TOOLBAR, TB_CHECKBUTTON, CMDID_VIEW_WEB, ByVal 0

            ' Set current view
            m_lCurrentView = 0
            lView = m_oCurrentView.View
            Set m_oCurrentView = ClassicView.object
            m_oCurrentView.View = lView
            
            ClassicView.Visible = True
            WebView.Visible = False
            
         End If
         
         ' Initialize the view
         m_oCurrentView.Initialize m_oIShellFolder, m_oBrowser, Me

         ' Refresh the view
         m_oCurrentView.Refresh
      
      Case CMDID_VIEW_LARGEICONS To CMDID_VIEW_DETAILS
      
         ' Set the new view
         m_oCurrentView.View = LOWORD(wParam) - CMDID_VIEW_LARGEICONS
          
         ' Update the checked menu tItem
         CheckMenuRadioItem m_hMenuView, CMDID_VIEW_LARGEICONS, CMDID_VIEW_DETAILS, LOWORD(wParam), MF_BYCOMMAND
         m_oBrowser.SendControlMsg FCW_TOOLBAR, TB_CHECKBUTTON, LOWORD(wParam), ByVal 1
        
      Case CMDID_TOOLS_VB
      
         ' Launch VB
         ShellExecute Me.hWnd, "open", "VB.EXE", vbNullString, vbNullString, SW_SHOW
         
   End Select
   
End Sub

'*********************************************************************************************
'
' OnMenuHighlight
'
' Called from the window procedure when a menu tItem
' is highlighted by the user
'
' Parameters:
'
' Cmd: CommandID of the highlighted menu tItem
'
'*********************************************************************************************
Friend Sub OnMenuHighlight(ByVal Cmd As Integer)
Dim sHelpStr As String

   Select Case Cmd
      
      Case CMDID_HELP_ABOUT
         sHelpStr = "Shows information about this namespace."
      
      Case CMDID_FILE_OPEN
         sHelpStr = "Opens the project in Visual Basic."
      
      Case CMDID_VIEW_WEB
         sHelpStr = "Displays the folder like a web page."
      
      Case CMDID_VIEW_LARGEICONS
         sHelpStr = "Displays items by using large icons."
      
      Case CMDID_VIEW_SMALLICONS
         sHelpStr = "Displays items by using small icons."
      
      Case CMDID_VIEW_LIST
         sHelpStr = "Displays items in a list."
      
      Case CMDID_VIEW_DETAILS
         sHelpStr = "Displays information about each tItem in the window."
         
      Case CMDID_TOOLS_VB
         sHelpStr = "Runs Visual Basic."
         
   End Select
   
   ' Show the help string on the
   ' browser's status bar
   m_oBrowser.SetStatusTextSB sHelpStr
   
End Sub

Friend Property Set ShellFolder(ByVal NewSF As IShellFolder)
   Set m_oIShellFolder = NewSF
End Property
Private Sub ClassicView_SelectionChanged(Title As String, FileName As String, Path As String)
   
   m_oBrowser.SetStatusTextSB "Location: " & Path

End Sub

Private Sub Form_Load()
Dim lStyle  As Long

   ' Add WS_CHILD style
   ' to this window
   lStyle = GetWindowLong(Me.hWnd, GWL_STYLE)
   lStyle = lStyle Or WS_CHILD
   SetWindowLong Me.hWnd, GWL_STYLE, lStyle
   
   ' Subclass the form to receive
   ' messages from menu items
   SetProp Me.hWnd, PROPS_OLDPROC, GetWindowLong(Me.hWnd, GWL_WNDPROC)
   SetProp Me.hWnd, PROPS_SHELLVIEW, ObjPtr(Me)
   SetWindowLong Me.hWnd, GWL_WNDPROC, AddressOf mdlSubclass.ShellViewProc
      
End Sub

Private Sub Form_Resize()

   On Error Resume Next
   
   WebView.Move 0, 0, ScaleWidth, ScaleHeight
   ClassicView.Move 0, 0, ScaleWidth, ScaleHeight
   
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim lOldProc As Long
   
   ' Unsubclass the form
   lOldProc = GetProp(Me.hWnd, PROPS_OLDPROC)
   SetWindowLong Me.hWnd, GWL_WNDPROC, lOldProc

End Sub

'*********************************************************************************************
'
' IShellView_AddPropertySheetPages
'
' Allows the view to add pages to the Options property sheet from the View menu.
'
'*********************************************************************************************
Private Sub IShellView_AddPropertySheetPages(ByVal dwReserved As Long, ByVal lpfn As Long, ByVal lParam As Long)
   
   ' No pages are added by this
   ' namespace. Return NOT IMPLEMENTED
   Err.Raise E_NOTIMPL

End Sub

'*********************************************************************************************
'
' IShellView_ContextSensitiveHelp
'
' Inherited from IOleWindow. Determines whether context-sensitive
' help mode should be entered during an in-place activation session.
'
'*********************************************************************************************
Private Sub IShellView_ContextSensitiveHelp(ByVal fEnterMode As Long)
   
   ' Return NOT IMPLEMENTED
   Err.Raise E_NOTIMPL

End Sub

'*********************************************************************************************
'
' IShellView_CreateViewWindow
'
' Creates a view window. This can be either the right pane of
' Windows Explorer or the client window of a folder window.
'
'*********************************************************************************************
Private Function IShellView_CreateViewWindow(ByVal lpPrevView As olelib.IShellView, lpfs As olelib.FOLDERSETTINGS, ByVal psb As olelib.IShellBrowser, prcView As olelib.RECT) As Long
Dim tFldrSet As FOLDERSETTINGS

   On Error Resume Next
   
   ' Save the browser object
   Set m_oBrowser = psb
           
   ' Resize the form and move it
   ' from desktop to browser
   SetParent Me.hWnd, m_oBrowser.GetWindow()
   MoveWindow Me.hWnd, prcView.Left, prcView.Top, prcView.Right, prcView.Bottom, 1
   
   ' Show/Hide controls
   If m_lCurrentView = 0 Then
         
      Set m_oCurrentView = ClassicView.object
      
      ClassicView.Visible = True
      WebView.Visible = False
      
   Else
      
      Set m_oCurrentView = WebView.object
      
      WebView.Visible = True
      ClassicView.Visible = False
      
   End If
   
   ' Refresh the view
   With m_oCurrentView
   
      ' Initialize the view
      .Initialize m_oIShellFolder, m_oBrowser, Me
      
      ' Get previous view settings
      lpPrevView.GetCurrentInfo tFldrSet
      
      ' Set the view mode
      .View = tFldrSet.ViewMode - 1
      
      ' Refresh the view
      .Refresh
      
   End With
   
   ' Return the form window handle
   IShellView_CreateViewWindow = Me.hWnd
   
   m_lSettingsFlags = lpfs.fFlags

   ' Initialize toolbar
   InitializeToolbar

   ' Reset the status bar
   m_oBrowser.SendControlMsg FCW_STATUS, SB_SETPARTS, 1, -1
      
   ' Show the Form
   ShowWindow Me.hWnd, SW_SHOW
        
End Function

'*********************************************************************************************
'
' IShellView_DestroyViewWindow
'
' Destroys the view window.
'
'*********************************************************************************************
Private Sub IShellView_DestroyViewWindow()
Dim oCV As IView
   
   ' Release the views
   Set oCV = WebView.object
   oCV.Destroy
   
   Set oCV = ClassicView.object
   oCV.Destroy
   
   ' Release the current view
   Set m_oCurrentView = Nothing
   
   ' Release the browser reference
   Set m_oBrowser = Nothing
   
   ' Release the folder reference
   Set m_oIShellFolder = Nothing
   
   ' Unload the form
   Unload Me
   
End Sub

'*********************************************************************************************
'
' IShellView_EnableModelessSV
'
' Enables or disables modeless dialog boxes.
'
'*********************************************************************************************
Private Sub IShellView_EnableModelessSV(ByVal fEnable As Long)

   Err.Raise E_NOTIMPL

End Sub

'*********************************************************************************************
'
' IShellView_GetCurrentInfo
'
' Retrieves the current folder settings.
'
'*********************************************************************************************
Private Sub IShellView_GetCurrentInfo(lpfs As FOLDERSETTINGS)
   
   lpfs.ViewMode = m_oCurrentView.View + 1
   lpfs.fFlags = m_lSettingsFlags
   
End Sub

'*********************************************************************************************
'
' IShellView_GetItemObject
'
' Retrieves an interface that refers to data presented in the view.
'
'*********************************************************************************************
Private Function IShellView_GetItemObject(ByVal uItem As Long, riid As olelib.UUID) As Long
      
   Err.Raise E_NOTIMPL

End Function

'*********************************************************************************************
'
' IShellView_GetWindow
'
' Inherited from IOleWindow. Returns the window handle to one of the windows
' participating in in-place activation (frame, document, parent, or
' in-place object window).
'
'*********************************************************************************************
Private Function IShellView_GetWindow() As Long

   ' Return the window handle
   IShellView_GetWindow = Me.hWnd
   
End Function

'*********************************************************************************************
'
' IShellView_Refresh
'
' Refreshes the view's contents in response to user input.
'
'*********************************************************************************************
Private Sub IShellView_Refresh()

   On Error Resume Next
   
   m_oCurrentView.Refresh
   
End Sub

'*********************************************************************************************
'
' IShellView_SaveViewState
'
' Saves the shell's view settings so the current state can be restored
' during a subsequent browsing session.
'
'*********************************************************************************************
Private Sub IShellView_SaveViewState()
  
   Err.Raise E_NOTIMPL
   
End Sub

'*********************************************************************************************
'
' IShellView_SelectItem
'
' Changes the selection state of one or more items within
' the shell view window.
'
'*********************************************************************************************
Private Sub IShellView_SelectItem(ByVal pidlItem As Long, ByVal uFlags As olelib.SVSI_Flags)

   Err.Raise E_NOTIMPL
   
End Sub

'*********************************************************************************************
'
' IShellView_TranslateAccelerator
'
' Translates accelerator key strokes when a namespace
' extension's view has the focus
'
'*********************************************************************************************
Private Sub IShellView_TranslateAccelerator(lpmsg As olelib.MSG)
  
   Err.Raise E_NOTIMPL

End Sub

'*********************************************************************************************
'
' IShellView_UIActivate
'
' Called when the activation state of the view window is changed
' by an event that is not caused by the shell view itself. For example,
' if the TAB key is pressed when the tree has the focus, the view should
' be given the focus.
'
'*********************************************************************************************
Private Sub IShellView_UIActivate(ByVal uState As olelib.SVUIA_STATUS)
   
   ' Initialize the menu bar
   ' it it was not initialized yet
   If m_hMenu = 0 Then InitializeMenus False
   
   ' Change menu state
   Select Case uState
      
      Case SVUIA_INPLACEACTIVATE, SVUIA_ACTIVATE_FOCUS
         
         ' Enable the open menu tItem
         EnableMenuItem m_hMenuFile, CMDID_FILE_OPEN, MF_BYCOMMAND Or MF_ENABLED
         
      Case SVUIA_ACTIVATE_NOFOCUS
         
         ' Disable open menu tItem
         EnableMenuItem m_hMenuFile, CMDID_FILE_OPEN, MF_BYCOMMAND Or MF_GRAYED
         
      Case SVUIA_DEACTIVATE
      
         ' Remove the menus
         DeleteMenus
         
   End Select
   
End Sub
'*********************************************************************************************
'
' IShellView2_CreateViewWindow2
'
' Creates the shell window for starting with an specific view
'
'*********************************************************************************************
Private Sub IShellView2_CreateViewWindow2(lpParams As olelib.SV2CVW2_PARAMS)
Dim tViewID As olelib.UUID
Dim tDefaultID As olelib.UUID
Dim tFS As olelib.FOLDERSETTINGS
Dim tRect As olelib.RECT

   On Error Resume Next
   
   With lpParams
   
      ' Get view ID
      MoveMemory tViewID, ByVal .pvUUID, LenB(tViewID)
      
      ' Convert the GUID to string
      CLSIDFromString SHELLVIEW_DEFAULT, tDefaultID
      
      If IsEqualGUID(tViewID, tDefaultID) Then
         m_lCurrentView = 0
      Else
         m_lCurrentView = 1
      End If
      
      ' Get FOLDERSETTINGS
      MoveMemory tFS, ByVal .pFOLDERSETTING, LenB(tFS)
      
      ' Get Rectangle
      MoveMemory tRect, ByVal .prcView, LenB(tRect)
      
      .hwndView = IShellView_CreateViewWindow(.psvPrev, tFS, .psbOwner, tRect)
      
   End With
   
End Sub

'*********************************************************************************************
'
' IShellView2_GetView
'
' Returns the ID of the requested view
'
'*********************************************************************************************
Private Sub IShellView2_GetView(pvid As olelib.UUID, ByVal uView As olelib.SV2GV_Flags)
   
   Select Case uView
      Case SV2GV_CURRENTVIEW
      
         If m_lCurrentView = 0 Then
            CLSIDFromString SHELLVIEW_DEFAULT, pvid
         Else
            CLSIDFromString SHELLVIEW_WEB, pvid
         End If
         
      Case 0, SV2GV_DEFAULTVIEW
      
         CLSIDFromString SHELLVIEW_DEFAULT, pvid
         
      Case 1
      
         CLSIDFromString SHELLVIEW_WEB, pvid
         
      Case Else
         Err.Raise E_FAIL
         
   End Select
   
End Sub

Private Sub IShellView2_HandleRename(ByVal pidlNew As Long)

   Err.Raise E_NOTIMPL
   
End Sub

Private Sub IShellView2_SelectAndPositionItem(ByVal pidlItem As Long, ByVal uFlags As olelib.SVSI_Flags, POINT As olelib.POINT)

   Err.Raise E_NOTIMPL

End Sub

Private Sub IShellView2_AddPropertySheetPages(ByVal dwReserved As Long, ByVal lpfn As Long, ByVal lParam As Long)
   IShellView_AddPropertySheetPages dwReserved, lpfn, lParam
End Sub

Private Sub IShellView2_ContextSensitiveHelp(ByVal fEnterMode As Long)
   IShellView_ContextSensitiveHelp fEnterMode
End Sub

Private Function IShellView2_CreateViewWindow(ByVal lpPrevView As olelib.IShellView, lpfs As olelib.FOLDERSETTINGS, ByVal psb As olelib.IShellBrowser, prcView As olelib.RECT) As Long
   IShellView2_CreateViewWindow = _
      IShellView_CreateViewWindow(lpPrevView, lpfs, psb, prcView)
End Function

Private Sub IShellView2_DestroyViewWindow()
   IShellView_DestroyViewWindow
End Sub

Private Sub IShellView2_EnableModelessSV(ByVal fEnable As Long)
   IShellView_EnableModelessSV fEnable
End Sub

Private Sub IShellView2_GetCurrentInfo(lpfs As olelib.FOLDERSETTINGS)
   IShellView_GetCurrentInfo lpfs
End Sub

Private Function IShellView2_GetItemObject(ByVal uItem As Long, riid As olelib.UUID) As Long
   IShellView2_GetItemObject = IShellView_GetItemObject(uItem, riid)
End Function

Private Function IShellView2_GetWindow() As Long
   IShellView2_GetWindow = IShellView_GetWindow
End Function

Private Sub IShellView2_Refresh()
   IShellView_Refresh
End Sub

Private Sub IShellView2_SaveViewState()
   IShellView_SaveViewState
End Sub

Private Sub IShellView2_SelectItem(ByVal pidlItem As Long, ByVal uFlags As olelib.SVSI_Flags)
   IShellView_SelectItem pidlItem, uFlags
End Sub

Private Sub IShellView2_TranslateAccelerator(lpmsg As olelib.MSG)
   IShellView_TranslateAccelerator lpmsg
End Sub

Private Sub IShellView2_UIActivate(ByVal uState As olelib.SVUIA_STATUS)
   IShellView_UIActivate uState
End Sub

