Attribute VB_Name = "mdlReplacedEntries"
'*********************************************************************************************
'
' Shell Namespace sample
'
' New VTable entries
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' Dependencies: OLELIB.TLB
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

'
' QueryContextMenu
'
' Adds the menu items to the context menu. This
' function replaces IContextMenu_QueryContextMenu
' because we need to return a value and VB can
' only implement functions that returns HRESULT.
'
' This: A reference to the object
' hMenu: Menu handle of context menu
' indexMenu: index of first menu tItem
' idCmdFirst: first command ID
' idCmdLast: last command ID
' uFlags: flags
'
Public Function IContextMenu_QueryContextMenu(ByVal This As IContextMenu, ByVal hMenu As Long, ByVal indexMenu As Long, ByVal idCmdFirst As Long, ByVal idCmdLast As Long, ByVal uFlags As Long) As Long
Dim oCtxMenu As ContextMenu

   Set oCtxMenu = This
   
   ' Call the object implementation
   ' of QueryContextMenu
   IContextMenu_QueryContextMenu = oCtxMenu.QueryContextMenu(hMenu, indexMenu, idCmdFirst, idCmdLast, uFlags)
    
   Set oCtxMenu = Nothing
   
End Function


Public Function IShellFolder_CompareIDs(ByVal This As IShellFolder, ByVal lParam As Long, ByVal pidl1 As Long, ByVal pidl2 As Long) As Long
Dim sName1 As String
Dim sName2 As String
Dim lAttr1 As Long
Dim lAttr2 As Long
Dim iCompare As Integer

   On Error Resume Next
   
   If pidl1 <> 0 And pidl2 <> 0 Then
   
      lAttr1 = GetPIDLAttributes(pidl1)
      lAttr2 = GetPIDLAttributes(pidl2)
      
      If (lAttr1 And SFGAO_FOLDER) = SFGAO_FOLDER And _
         (lAttr2 And SFGAO_FOLDER) = 0 Then
            
         iCompare = -1 ' Folders first
         
      ElseIf (lAttr2 And SFGAO_FOLDER) = SFGAO_FOLDER And _
         (lAttr1 And SFGAO_FOLDER) = 0 Then
         
         iCompare = 1 ' Folders first
         
      Else
      
         ' Get the filenames
         sName1 = GetFilename(GetPIDLName(pidl1))
         sName2 = GetFilename(GetPIDLName(pidl2))
         
         ' Compare the filenames
         iCompare = StrComp(sName1, sName2, vbTextCompare)
      
      End If
      
      ' Return the value as a long
      MoveMemory IShellFolder_CompareIDs, iCompare, 2
      
   Else
   
      ' Return invalid argument error
      IShellFolder_CompareIDs = E_INVALIDARG
      
   End If
   
End Function



