Attribute VB_Name = "mdlFunctions"
'*********************************************************************************************
'
' Shell Namespace sample
'
' Global functions & API declarations
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested on: Windows 98 + VB5
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

' Shell IMalloc interface
Public g_oMalloc As IMalloc

' Interface IDs
Public IID_IShellView As olelib.UUID
Public IID_IShellView2 As olelib.UUID
Public IID_IExtractIconA As olelib.UUID
Public IID_IExtractIconW As olelib.UUID
Public IID_IQueryInfo As olelib.UUID
Public IID_IContextMenu As olelib.UUID

' Recent files registry key
Public Const REG_KEYVB5 = "Software\Microsoft\Visual Basic\5.0\RecentFiles"
Public Const REG_KEYVB6 = "Software\Microsoft\Visual Basic\6.0\RecentFiles"

Public Const REG_CONFIG = "Software\Edanmo\Recent Projects"
Public Const REG_CONFIG_VER = "VBVersion"

Public Const SHELLVIEW_DEFAULT = "{07ED0044-DD03-11d4-B99A-BC00EF81C04A}"
Public Const SHELLVIEW_WEB = "{07ED0045-DD03-11d4-B99A-BC00EF81C04A}"

' ---- API declarations -----

Public Const WS_CHILD = &H40000000
Public Const WS_BORDER = &H800000

Public Const GWL_WNDPROC = (-4)
Public Const GWL_STYLE = (-16)
Public Const GWL_EXSTYLE = (-20)

Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const SW_SHOW = 5

Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long

Declare Function SetWindowPos Lib "user32" ( _
    ByVal hWnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal uFlags As Long) As Long

Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_FRAMECHANGED = &H20

Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Public Const WM_ACTIVATE = &H6&
Public Const WM_SETFOCUS = &H7
Public Const WM_KILLFOCUS = &H8
Public Const WM_NOTIFY = &H4E&
Public Const WM_COMMAND = &H111&
Public Const WM_MENUSELECT = &H11F&

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)

Declare Function LoadImage Lib "user32" Alias "LoadImageA" ( _
   ByVal hInst As Long, _
   ByVal lpszName As Any, _
   ByVal uType As Long, _
   ByVal cxDesired As Long, _
   ByVal cyDesired As Long, _
   ByVal fuLoad As Long) As Long
   
Declare Function ImageList_ReplaceIcon Lib "comctl32" ( _
   ByVal himl As Long, _
   ByVal i As Long, _
   ByVal hicon As Long) As Long

Declare Function GetLongPathName Lib "kernel32" Alias "GetLongPathNameA" ( _
  ByVal lpszShortPath As String, _
  ByVal lpszLongPath As String, _
  ByVal cchBuffer As Long) As Long

' Shell APIs
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile As String, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIcons As Long) As Long

' Properties APIs
Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long

' GUID APIs
Public Declare Function IsEqualGUID Lib "ole32" (rguid1 As olelib.UUID, rguid2 As olelib.UUID) As Long

' Memory APIs
Public Declare Function VirtualProtect Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long
Public Const PAGE_EXECUTE_READWRITE& = &H40&

' String APIs
Public Declare Function lstrcpyA Lib "kernel32" (Str1 As Any, Str2 As Any) As Long
Public Declare Function lstrlenA Lib "kernel32" (Str1 As Any) As Long
Public Declare Function lstrcpynA Lib "kernel32" (lpString1 As Any, lpString2 As Any, ByVal MaxLen As Long) As Long

' Registry APIs

Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const KEY_ALL_ACCESS = &HF003F

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegEnumValueStr Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryInfoKey Lib "advapi32" Alias "RegQueryInfoKeyA" _
               (ByVal hKey As Long, ByVal lpClass As Any, lpcbClass As Long, _
               ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, _
               lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, _
               lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, _
               lpftLastWriteTime As Any) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

' Menu APIs

Type MENUITEMINFO
   cbSize As Long
   fMask As Long
   fType As Long
   fState As Long
   wID As Long
   hSubMenu As Long
   hbmpChecked As Long
   hbmpUnchecked As Long
   dwItemData As Long
   dwTypeData As String
   cch As Long
End Type

Public Const MIIM_SUBMENU = &H4

Declare Function CreateMenu Lib "user32" () As Long
Declare Function CreatePopupMenu Lib "user32" () As Long
Declare Function DestroyMenu Lib "user32" (ByVal hMenu As Long) As Long
Declare Function InsertMenu Lib "user32" Alias "InsertMenuA" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal uFlags As Long, ByVal uIDNewItem As Long, ByVal lpNewItem As String) As Boolean
Declare Function DeleteMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal b As Boolean, lpMenuItemInfo As MENUITEMINFO) As Long
Declare Function CheckMenuItem Lib "user32" (ByVal hMenu As Long, ByVal uIDCheckItem As Long, ByVal uCheck As Long) As Long
Declare Function CheckMenuRadioItem Lib "user32" (ByVal hMenu As Long, ByVal un1 As Long, ByVal un2 As Long, ByVal un3 As Long, ByVal un4 As Long) As Long
Declare Function SetMenuDefaultItem Lib "user32" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPos As Long) As Long
Declare Function EnableMenuItem Lib "user32" (ByVal hMenu As Long, ByVal wIDEnableItem As Long, ByVal wEnable As Long) As Long

Public Const MF_BYCOMMAND = &H0&
Public Const MF_ENABLED = &H0&
Public Const MF_GRAYED = &H1&
Public Const MF_DISABLED = &H2&
Public Const MF_BYPOSITION = &H400&
Public Const MF_SEPARATOR = &H800&
Public Const MF_UNCHECKED = &H0&
Public Const MF_CHECKED = &H8&

Public Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" (ByVal lpString As String) As Long

Public Function FileExist(ByVal sFile As String) As Boolean

   FileExist = Dir(sFile) <> ""
   
End Function

'
' GetFileName
'
' Returns the file name from a fully qualified path
'
Public Function GetFilename(ByVal FullPath As String) As String
Dim lIdx As Long

   For lIdx = Len(FullPath) To 0 Step -1
      
      If Mid$(FullPath, lIdx, 1) = "\" Then
      
         GetFilename = Mid$(FullPath, lIdx + 1)
         Exit For
         
      End If
      
   Next
   
End Function


'
' GetFolder
'
' Returns the folder name from a fully qualified path
'
Public Function GetFolder(ByVal FullPath As String) As String
Dim lIdx As Long

   For lIdx = Len(FullPath) To 0 Step -1
      
      If Mid$(FullPath, lIdx, 1) = "\" Then
      
         GetFolder = Left$(FullPath, lIdx - 1)
         Exit For
         
      End If
      
   Next
   
End Function
Function GetLongPath(ByVal Path As String) As String

   On Error Resume Next
   
   GetLongPath = Path & String$(260, 0)
   
   Debug.Print GetLongPathName(Path, GetLongPath, Len(GetLongPath))
   
   GetLongPath = RTrimNull(GetLongPath)
   
End Function

'
' GetProjectTitle
'
' Returns the project name
'
Public Function GetProjectTitle(ByVal sFile As String) As String
Dim lFileNum As Long
Dim sLine As String, lPos As Long

   If IsProject(sFile) Then
      
      lFileNum = FreeFile
      
      ' Open the file
      Open sFile For Input As lFileNum
      
      ' Find the Title entry
      Do Until EOF(lFileNum) Or InStr(sLine, "Title=")
         Line Input #lFileNum, sLine
      Loop
      
      ' Close the file
      Close lFileNum
      
      lPos = InStr(sLine, "Title=")
      
      If lPos Then
         GetProjectTitle = Trim$(Mid$(sLine, lPos + 6))
         If Left$(GetProjectTitle, 1) = """" Then GetProjectTitle = Mid$(GetProjectTitle, 2, Len(GetProjectTitle) - 2)
      Else
         GetProjectTitle = GetFilename(sFile)
         GetProjectTitle = Left$(GetProjectTitle, Len(GetProjectTitle) - 4)
      End If
   
   Else
   
      ' sFile is a project group
      ' Return the file name without
      ' extension
   
      GetProjectTitle = GetFilename(sFile)
      GetProjectTitle = Left$(GetProjectTitle, Len(GetProjectTitle) - 4)
      
   End If
   
End Function


'
' Gets the VB version for the recent projects
'
Function GetVBVersion() As Long
Dim hKey As Long

   If RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_CONFIG, 0, KEY_ALL_ACCESS, hKey) = 0 Then
   
      RegQueryValueEx hKey, REG_CONFIG_VER, 0, 0, GetVBVersion, 4
      
      RegCloseKey hKey
      
   Else
      GetVBVersion = 5
   End If
   
End Function

'
' IsProject
'
' Returns whether the file is a project (vbp).
'
Public Function IsProject(ByVal sFile As String) As Boolean

   IsProject = UCase$(Right$(sFile, 3)) = "VBP"
   
End Function

Public Function LOWORD(ByVal DWORD As Long) As Integer

   MoveMemory LOWORD, DWORD, 2
   
End Function

'
' Main
'
' Entry point of the dll
'
Sub Main()

   ' Initialize IIDs
   CLSIDFromString IIDSTR_IShellView, IID_IShellView
   CLSIDFromString IIDSTR_IShellView2, IID_IShellView2
   CLSIDFromString IIDSTR_IExtractIconA, IID_IExtractIconA
   CLSIDFromString IIDSTR_IExtractIconW, IID_IExtractIconW
   CLSIDFromString IIDSTR_IQueryInfo, IID_IQueryInfo
   CLSIDFromString IIDSTR_IContextMenu, IID_IContextMenu
   
   ' Get the shell allocator object
   Set g_oMalloc = SHGetMalloc()
   
End Sub
Sub PrintGUID(riid As UUID)
      Dim S As String
      S = Space$(38)
      StringFromGUID2 riid, S, 39
      Debug.Print S
End Sub

'
' Replaces an entry in a object v-table
'
Public Function ReplaceVTableEntry(ByVal oObject As Long, ByVal nEntry As Integer, ByVal pFunc As Long) As Long
Dim pFuncOld As Long, pVTableHead As Long
Dim pFuncTmp As Long, lOldProtect As Long
     
    ' Object pointer contains a pointer to v-table--copy it to temporary
    ' pVTableHead = *oObject;
    MoveMemory pVTableHead, ByVal oObject, 4
    
    ' Calculate pointer to specified entry
    pFuncTmp = pVTableHead + (nEntry - 1) * 4
    
    ' Save address of previous method for return
    ' pFuncOld = *pFuncTmp;
    MoveMemory pFuncOld, ByVal pFuncTmp, 4
    
    ' Ignore if they're already the same
    If pFuncOld <> pFunc Then
    
        ' Need to change page protection to write to code
        VirtualProtect pFuncTmp, 4, PAGE_EXECUTE_READWRITE, lOldProtect
        
        ' Write the new function address into the v-table
        MoveMemory ByVal pFuncTmp, pFunc, 4     ' *pFuncTmp = pfunc;
        
        ' Restore the previous page protection
        VirtualProtect pFuncTmp, 4, lOldProtect, lOldProtect 'Optional
        
    End If
    
    'return address of original proc
    ReplaceVTableEntry = pFuncOld
    
End Function

'
' StrFromPtr
'
' Returns a string from a pointer to an ANSI string
'
Public Function StrFromPtr(ByVal Ptr As Long) As String

   StrFromPtr = String$(lstrlenA(ByVal Ptr), 0)
   lstrcpyA ByVal StrFromPtr, ByVal Ptr
   
End Function




