Attribute VB_Name = "mdlIDLIST"
'*********************************************************************************************
'
' Shell Namespace sample
'
' IDLIST functions
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested with:
'              Windows Me/XP
'              VB6
'              IE 6
'
' History:
'          04/03/2000 - The file was released
'
'*********************************************************************************************
Option Explicit

Type CIDA
    cidl As Long
    OffsetPath As Long
    OffsetItem As Long
End Type

' Each IDITEM has the following format:
'
' length       Integer  Item length (including this member)
' attributes   Long     Item attributes
' name         String   Item name

Const PIDL_OFFSET_ATTRIBUTES = 2
Const PIDL_OFFSET_STRING = 6
Function AddPIDLs(ByVal RootPIDL As Long, ByVal PIDL As Long) As Long
Dim lS1 As Long
Dim lS2 As Long

   ' Get the PIDLs sizes
   lS1 = GetPIDLSize(RootPIDL)
   lS2 = GetPIDLSize(PIDL) + 2
   
   ' Allocate the memory
   AddPIDLs = g_oMalloc.Alloc(lS1 + lS2)
   
   ' Copy the PIDLS
   MoveMemory ByVal AddPIDLs, ByVal RootPIDL, lS1
   MoveMemory ByVal AddPIDLs + lS1, ByVal PIDL, lS2

End Function


Function CopyPIDL(ByVal PIDL As Long) As Long
Dim lSize As Long
   
   ' Get the PIDL size
   lSize = GetPIDLSize(PIDL) + 2
   
   ' Copy the IDLIST
   CopyPIDL = g_oMalloc.Alloc(lSize)

   MoveMemory ByVal CopyPIDL, ByVal PIDL, lSize
   
End Function


Public Function GetPIDLSize(ByVal PIDL As Long) As Long
Dim cb As Integer
    
   If PIDL Then
                
      MoveMemory cb, ByVal PIDL, 2
      
      Do While cb
                         
         GetPIDLSize = GetPIDLSize + cb
         PIDL = PIDL + cb
         
         MoveMemory cb, ByVal PIDL, 2
         
      Loop
           
   End If

End Function


Public Function CreateSimplePIDL(ByVal Item As String, ByVal Attr As SFGAO_Flags) As Long
Dim iCB As Integer

   ' Calculate PIDL size
   iCB = LenB(iCB) + LenB(Attr) + LenB(Item) + 2
   
   ' Allocate the memory for the lPIDL
   CreateSimplePIDL = g_oMalloc.Alloc(iCB + 2)
   
   ' Set the PIDL length
   MoveMemory ByVal CreateSimplePIDL, iCB, 2&
   
   ' Copy the attributtes
   MoveMemory ByVal CreateSimplePIDL + PIDL_OFFSET_ATTRIBUTES, Attr, 4&
   
   ' Copy the string
   MoveMemory ByVal CreateSimplePIDL + PIDL_OFFSET_STRING, ByVal StrPtr(Item), LenB(Item) + 2
   
   ' Clear the last 2 bytes
   ZeroMemory ByVal CreateSimplePIDL + iCB, 2&
   
End Function
Public Function GetPIDLName(ByVal lPIDL As Long) As String
   
   On Error Resume Next
   
   If lPIDL Then
      GetPIDLName = SysAllocString(lPIDL + PIDL_OFFSET_STRING)
   End If
         
End Function


Public Function GetPIDLAttributes(ByVal lPIDL As Long) As SFGAO_Flags

   ' Copy the attributes from the lPIDL
   MoveMemory GetPIDLAttributes, ByVal lPIDL + PIDL_OFFSET_ATTRIBUTES, 4&
   
End Function

